package com.ajou.prcoding.myweb.service;

import java.io.IOException;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.client.RestTemplate;

import com.ajou.prcoding.myweb.dto.FavoriteMusicRequestDto;
import com.ajou.prcoding.myweb.dto.MusicList;
import com.ajou.prcoding.myweb.entity.FavoriteMusic;
import com.ajou.prcoding.myweb.repository.FavoriteRepository;
import com.fasterxml.jackson.databind.ObjectMapper;

import jakarta.transaction.Transactional;
import lombok.RequiredArgsConstructor;

@Service
@Transactional
@RequiredArgsConstructor
public class MusicService {
    RestTemplate restTemplate = new RestTemplate();

    public MusicList musicSearchByPath(@PathVariable String term) {
        try {
            String response = restTemplate.getForObject("https://itunes.apple.com/search?term={term}&entity=album", String.class, term);
            ObjectMapper mapper = new ObjectMapper();
            MusicList list = mapper.readValue(response, MusicList.class);
            System.out.println(list.getResultCount());
            return list;
            } catch(IOException e) {
                System.out.println(e.toString());
            }
        return null;
    }

    public MusicList searchMusic(@RequestParam String term) { 
        try {
            String response = restTemplate.getForObject("https://itunes.apple.com/search?term={term}&entity=album", String.class, term);
            ObjectMapper mapper = new ObjectMapper();
            MusicList list = mapper.readValue(response, MusicList.class);
            System.out.println(list.getResultCount());
            return list;
            } catch(IOException e) {
                System.out.println(e.toString());
            }
        return null;
    }
    
    @Autowired
    FavoriteRepository albumsRepo;

    public List<FavoriteMusic> getLikes() {
    try {
        return albumsRepo.findAll();
        } catch (Exception e) {
            System.out.println(e.toString());
            return null;
        }
    }

    @Transactional
    public int saveFavorite(@RequestBody FavoriteMusicRequestDto favorite)
    {
    FavoriteMusic music = albumsRepo.save(favorite.toEntity());
    if(music != null) {
        return 1;
    }
    else {
        return 0;
    }
    }
}